function Object:setPos(x, y)
   self.x = x
   self.y = y
end

function Object:getPos()
   return self.x, self.y
end


--credit to Kadoba for this functions... why reinvent the wheel ;)
 
-- Moves the object to the relative location
function Object:move(x, y)
   self.x, self.y = self.x + x or 0, self.y + y or 0
end

-- Moves the object to the absolute location
function Object:moveTo(x, y)
   self.x, self.y = x or self.x, y or self.y
end

-- Moves the object towards the given location
function Object:moveToward(x, y, speed)
   if self.x == x and self.y == y then return end
   local dirx, diry = x - self.x, y - self.y
   local dist = math.sqrt(dirx*dirx + diry*diry)
   if dist > speed*2 then
      self:move(dirx/dist*speed, diry/dist*speed)
   else
      self:moveTo(x,y)
   end
   return true
end

-- Moves the object towards the direction (in degrees)
function Object:moveDir(dir, speed)
   local x = math.cos(math.rad(dir))
   local y = -math.sin(math.rad(dir))
   self:move(x*speed, y*speed)
end

return Object