
anim8 = require 'anim8'
require("middleclass")
Jumper = require 'Jumper'
require("pathfinder")


--********************************************************************************--
function love.load()
--	love.graphics.setMode(1280, 720, false, true, 4)
	
	image = love.graphics.newImage('13sprite.png')
	
	winh = love.graphics.getHeight( )
	winw = love.graphics.getWidth( )
  
--****** ATL ******--  
	loader = require("AdvTiledLoader/Loader")
	loader.path = "maps/" --Change this to wherever your .tmx files are
	map = loader.load("Tiledmap6.tmx") --Change this to the name of your mapfile
	map.useSpriteBatch = true
	map.drawBefore = 4 -- moded for drawing before layer
  

	worldmap = {
	tx = 0,
	ty = 0,
	xscroll = winw*0.2,
	yscroll = winh*0.2,
	scale = 1 , 
	}
	ftx, fty = 0
	
    canvas = love.graphics.newCanvas( winw, winh )
		
	TLbind,control = love.filesystem.load("TLbind.lua")()
	TLbind.keys = {
    w="sup", a="sleft", s="sdown", d="sright", [" "]="jump", lctrl="attack", escape="menu",
    up="up", left="left", down="down", right="right", z="jump", rctrl="attack",}
	

--****** Jumper ******--
	path, cost = nil
	
	wmap = walkmap(map.width, map.height, "Collision")
	
--		wmap = walkmap(map.height,map.width, "Collision")
	
	walkable = 0
	allowDiagonal = true
	smoothpath = false
	drawpath = true
	pather = Jumper(wmap,walkable,allowDiagonal)

	
--******  Player ******--
	player = {}
 	playerAnim = anim8.newGrid(32, 48, image:getWidth(), image:getHeight())
	player.anim = anim8.newAnimation('loop', playerAnim('1-4,1'), 0.3)
	player.speed = 300
 --	player.px = 200
--	player.py = 200
	player.direction = "down" 

	pp = require 'Object_move'
	pp:setPos(100, 100)
	 
end

function love.update(dt)
	
x1, y1 = pp:getPos()

	sx = x1 + worldmap.tx
	sy = y1 + worldmap.ty
	TLbind:update()
  	player.anim:update(dt)

	if control.sup then worldmap.ty = worldmap.ty + player.speed*dt end
	if control.sdown then worldmap.ty = worldmap.ty - player.speed*dt end
	if control.sleft then worldmap.tx = worldmap.tx + player.speed*dt end
	if control.sright then worldmap.tx = worldmap.tx - player.speed*dt end
  
	-- scroll when near screen border
		if sy < worldmap.yscroll  then
			if worldmap.ty < 0 then
				worldmap.ty = worldmap.ty + player.speed*dt
			else
				worldmap.ty = 0
			end
		end

		if sy > winh-worldmap.yscroll then
			if -worldmap.ty < ((map.tileHeight * map.height)-winh) then
				worldmap.ty = worldmap.ty - player.speed*dt
			else
				worldmap.ty = -((map.tileHeight * map.height)-winh)
			end
		end

		if sx < worldmap.xscroll then
			if worldmap.tx < 0 then		
				worldmap.tx = worldmap.tx + player.speed*dt
			else
				worldmap.tx = 0
			end
		end

		if sx > winw - worldmap.xscroll then
			if -worldmap.tx < ((map.width * map.tileWidth)-winw) then	
				worldmap.tx = worldmap.tx - player.speed*dt
			else
				worldmap.tx = -((map.width * map.tileWidth)-winw)
			end
		end
movePath(dt)

end



--********************************************************************************--
function love.draw()
	prnty = 0
	ftx, fty = math.floor(worldmap.tx), math.floor(worldmap.ty)
	map:predraw() 
	love.graphics.push()
		love.graphics.translate(ftx, fty)
		love.graphics.scale(1/worldmap.scale)
		map:xdraw()
		map:autoDrawRange(ftx, fty, 1/worldmap.scale, 64/worldmap.scale)
		if drawpath then
			drawPath()
		end
	love.graphics.pop()
	
	pr("fps = " .. love.timer.getFPS( ))
	
	if allowDiagonal then
		pr("(z) allowDiagonal = true")
	else
		pr("(z) allowDiagonal = false")
	end
	
	if smoothpath then
		pr("(x) smoothpath = true")
	else
		pr("(x) smoothpath = false")
	end
		
	if drawpath then
		pr("(c) drawpath = true")
	else
		pr("(c) drawpath = false")
	end
		
	if path then
		pr("Cost = " .. cost)
	end
	
end
--********************************************************************************--

function pr(var)
	prnty = prnty + 10
	love.graphics.print( var, 10, prnty)
end


function drawBeforeLayer()
	
	ppx, ppy = pp:getPos()
	scale = 1
	player.anim:draw(image,ppx,ppy,0,scale,scale,32,56)
	
--	player.c:draw('line')
end

function love.mousepressed(x,y,button)
	
	if button == 'l' then
		if not path then
			startx, starty = pp:getPos()
			makepath(startx, starty, (x-ftx)*worldmap.scale, (y-fty)*worldmap.scale, allowDiagonal, smoothpath)
		end
	elseif button =='r' then

	end
end

function love.keypressed(k)
	if k == "z" then
		allowDiagonal = switch(allowDiagonal)
	elseif k == "x" then
		smoothpath = switch(smoothpath)
	elseif k == "c" then
		drawpath = switch(drawpath)
	end
end


function switch(test)
	if test then return false end
	if not test then return true end
end
